# Class Synthetic

java.lang.Object
org.apache.bcel.classfile.Attribute
org.apache.bcel.classfile.Synthetic

All Implemented Interfaces:
  `Cloneable, Node`

public final class Synthetic extends Attribute
This class is derived from Attribute and declares this class as 'synthetic', that is, it needs special handling. The JVM specification states "A class member that does not appear in the source code must be marked using a Synthetic attribute." It may appear in the ClassFile attribute table, a field_info table or a method_info table. This class is intended to be instantiated from the Attribute.readAttribute() method.

    Synthetic_attribute {
        u2 attribute_name_index;
        u4 attribute_length;
    }

See Also:
  - `Attribute`
  - JVM Specification: The Synthetic Attribute

- ## Field Summary

  ### Fields inherited from class Attribute

  `constant_pool, EMPTY_ARRAY, length, name_index, tag`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `Synthetic(int nameIndex, int length, byte[] bytes, ConstantPool constantPool)`
  `Synthetic(Synthetic c)`
  Initialize from another object.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `accept(Visitor v)`
  Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class.
  `Attribute`
  `copy(ConstantPool constantPool)`
  Creates a deep copy of this attribute.
  `byte[]`
  `getBytes()`
  Gets data bytes.
  `void`
  `setBytes(byte[] bytes)`
  Sets data bytes.
  `String`
  `toString()`

  ### Methods inherited from class Attribute

  `addAttributeReader, addAttributeReader, clone, dump, getConstantPool, getLength, getName, getNameIndex, getTag, println, readAttribute, readAttribute, removeAttributeReader, setConstantPool, setLength, setNameIndex`

  ### Methods inherited from class Object

  `equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### Synthetic

    public Synthetic(int nameIndex, int length, byte[] bytes, ConstantPool constantPool)
    Parameters:
      `nameIndex` - Index in constant pool to CONSTANT_Utf8, which should represent the string "Synthetic".
      `length` - JVM Specification: "The value of the attribute_length item must be zero.".
      `bytes` - Attribute contents.
      `constantPool` - The constant pool this attribute is associated with.
    See Also:
      - JVM Specification: The Synthetic Attribute

  - ### Synthetic

    public Synthetic(Synthetic c)
    Initialize from another object. Note that both objects use the same references (shallow copy). Use copy() for a physical copy.
    Parameters:
      `c` - Source to copy.

- ## Method Details

  - ### accept

    public void accept(Visitor v)
    Called by objects that are traversing the nodes of the tree implicitly defined by the contents of a Java class. I.e., the hierarchy of methods, fields, attributes, etc. spawns a tree of objects.
    Specified by:
      `accept` in interface `Node`
    Specified by:
      `accept` in class `Attribute`
    Parameters:
      `v` - Visitor object.

  - ### copy

    public Attribute copy(ConstantPool constantPool)
    Description copied from class: `Attribute`
    Creates a deep copy of this attribute.
    Specified by:
      `copy` in class `Attribute`
    Parameters:
      `constantPool` - constant pool to save.
    Returns:
      deep copy of this attribute.

  - ### getBytes

    public byte[] getBytes()
    Gets data bytes.
    Returns:
      data bytes.

  - ### setBytes

    public void setBytes(byte[] bytes)
    Sets data bytes.
    Parameters:
      `bytes` - data bytes.

  - ### toString

    public String toString()
    Overrides:
      `toString` in class `Attribute`
    Returns:
      String representation.